program heatnum
  implicit none

  integer :: nx, ny
  double precision,dimension(:,:,:), allocatable :: v
  integer :: iterx, itery, new, old,iter
  double precision :: diff, delta

  nx = 500
  ny = 300

  allocate(v(nx,ny,2))
  v(:,:,:) = 0.d0
  do iterx=1, nx
    v(iterx,1,1) = iterx 
    v(iterx,1,2) = iterx
    v(iterx,ny,1) = iterx+(ny-1)*nx
    v(iterx,ny,2) = iterx+(ny-1)*nx
  end do
  do itery=1,ny
    v(1,itery,1) = 1+(itery-1)*nx
    v(1,itery,2) = 1+(itery-1)*nx
    v(nx,itery,1) = nx+(itery-1)*nx
    v(nx,itery,2) = nx+(itery-1)*nx
  end do

  new = 2
  old = 1
  diff = 1000000.d0
  iter = 0

  do while (diff > 1e-7)
    diff = 0.d0
    do itery=2, ny-1
      do iterx=2, nx-1
        v(iterx,itery,new) = (v(iterx-1,itery+1,old)+v(iterx,itery+1,old)+v(iterx+1,itery+1,old)+ &
                              v(iterx-1,itery,old)+v(iterx,itery,old)+v(iterx+1,itery,old)+ &
                              v(iterx-1,itery-1,old)+v(iterx,itery-1,old)+v(iterx+1,itery-1,old))/9.d0
        delta = abs(v(iterx,itery,new)-v(iterx,itery,old))
        if (delta > diff) diff = delta
      end do
    end do
    iter = iter+1
    old = new
    new = 2-mod(old+1,2)
  end do

  print *, iter, diff, v(nx/2, ny/2, old), nx/2+(ny/2-1)*nx
end program
