program argmin
  implicit none

  integer, parameter    :: N = 8192
  real, dimension(N)    :: a
  integer               :: k,iter,sample
  real                  :: start,finish
  integer, parameter    :: simdWidth=16
  integer, dimension(simdWidth) :: ksimd
  real, dimension(simdWidth) :: asimd
  integer :: isimd

  call random_number(a)

  call cpu_time(start)
  do sample =1, 600000
    ! argmin
    do iter=1,simdWidth
      ksimd(iter) = iter
      asimd(iter) = a(iter)
    end do
    k=1
    a(N) = sample
    ! Vector section
    do iter=simdWidth+1,simdWidth*(N/simdWidth),simdWidth
      !$omp simd
      do isimd=1,simdWidth
        if (a(iter+isimd-1) < asimd(isimd)) then
          ksimd(isimd) = iter+isimd-1
          asimd(isimd) = a(iter+isimd-1)
        end if
      end do
    end do
    ! Remainder section
    do iter=iter+1,N
      if ( a(iter) < asimd(1) ) then
        ksimd(1) = iter
        asimd(1) = a(iter)
      end if
    end do

    ! Meld vector of least
    k = ksimd(1)
    do isimd=2,simdWidth
      if (asimd(isimd) < a(k) ) then
        k = ksimd(isimd)
      end if
    end do
  end do
  call cpu_time(finish)
  print *, finish-start,"s",N*sample/((finish-start)*1000000),"Mit/s",a(k)

end program argmin
